#============================================================================
# perl_prog_module .mk

PERL_PROG_MODULE_MK =

# support for Perl programs with their own modules.  Modules are converted
# from %.pm.in via substitiution.  The modules should set their versions
# from @VERSION@ so that the main program can use that to verify that
# the correct version of the modules are loaded.

#--------------------------------------
# prerequisite snippets
SUBSTITUTE_CONFIG_VARIABLES_MK +=
CREATE_AM_MACROS_MK +=
PERL_COMPILE_MK +=

#--------------------------------------
# prerequisite make variables

# where compiled modules live in the build tree
PERL_MODULE_BUILD_DIR +=

# where compiled modules are installed
PERL_MODULE_INSTALL_DIR +=

# The list of perl modules, ending with .pm
PERL_MODULES +=

#--------------------------------------

BUILT_PERL_MODULES = $(PERL_MODULES:%=$(PERL_MODULE_BUILD_DIR)/%)

# ensure that the build directory is created and destroyed
$(PERL_MODULE_BUILD_DIR) :
	test ! -d $@ && mkdir -p $@

clean-local :
	rm -rf $(PERL_MODULE_BUILD_DIR)

# substitution & compilation rule
$(PERL_MODULE_BUILD_DIR)/%.pm : %.pm.in Makefile
	p="$@"; f=$(strip_dir) \
	$(do_subst) $(srcdir)/$$f.in > $@ ; \
	$(PERL_COMPILE) $@ || { rm $@; false ; }

# substitution & compilation rule
$(PERL_MODULE_BUILD_DIR)/%.pm : %.pm Makefile
	p="$@"; f=$(strip_dir) \
	$(PERL_COMPILE) $(srcdir)/$$f
	p="$@"; f=$(strip_dir) \
	cp $(srcdir)/$$f $@

#--------------------------------------

BUILT_SOURCES += \
		$(PERL_MODULE_BUILD_DIR) \
		$(BUILT_PERL_MODULES)


CLEANFILES += 	\
		$(PERL_MODULE_BUILD_DIR)

#--------------------------------------
# support for automake copy

perl_moduledir = $(PERL_MODULE_INSTALL_DIR)
perl_module_DATA = $(BUILT_PERL_MODULES)
